.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDE    \masm32\include\comctl32.inc
INCLUDELIB \masm32\lib\comctl32.lib
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD

.CONST

IDC_PROGRESS EQU 1
IDC_STATUS   EQU 2
IDC_TIMER    EQU 3

.DATA

ClassName     DB "CommonControlWinClass", 0
AppName       DB "Demonstracja typowych kontrolek", 0
ProgressClass DB "msctls_progress32", 0
Message       DB "Skoczone!", 0
TimerID       DD 0

.DATA?

hInstance    HINSTANCE ?
hwndProgress DD        ?
hwndStatus   DD        ?
CurrentStep  DD        ?

.CODE

start:
    INVOKE GetModuleHandle,  NULL
    mov    hInstance, eax
    INVOKE WinMain,  hInstance, NULL, NULL,  SW_SHOWDEFAULT
    INVOKE ExitProcess, eax
    INVOKE InitCommonControls

WinMain PROC hInst:     HINSTANCE,\
             hPrevInst: HINSTANCE,\
             CmdLine:   LPSTR,\
             CmdShow:   DWORD

LOCAL wc:   WNDCLASSEX
LOCAL msg:  MSG
LOCAL hwnd: HWND

    mov    wc.cbSize, SIZEOF WNDCLASSEX
    mov    wc.style, CS_HREDRAW OR CS_VREDRAW
    mov    wc.lpfnWndProc, OFFSET WndProc
    mov    wc.cbClsExtra, NULL
    mov    wc.cbWndExtra, NULL
    push   hInst
    pop    wc.hInstance
    mov    wc.hbrBackground, COLOR_APPWORKSPACE
    mov    wc.lpszMenuName, NULL
    mov    wc.lpszClassName, OFFSET ClassName
    INVOKE LoadIcon, NULL, IDI_APPLICATION
    mov    wc.hIcon, eax
    mov    wc.hIconSm, eax
    INVOKE LoadCursor, NULL, IDC_ARROW
    mov    wc.hCursor, eax
    INVOKE RegisterClassEx, ADDR wc
    INVOKE CreateWindowEx, WS_EX_CLIENTEDGE,\
                           ADDR ClassName, ADDR AppName,\
                           WS_OVERLAPPED + WS_CAPTION + \
                           WS_SYSMENU + WS_MINIMIZEBOX + \
                           WS_MAXIMIZEBOX + WS_VISIBLE,\
                           CW_USEDEFAULT, CW_USEDEFAULT,\
                           400, 200, NULL, NULL, hInst, NULL
    mov    hwnd, eax

    .WHILE TRUE
        INVOKE GetMessage, ADDR msg, NULL, 0, 0
        .BREAK .IF (!eax)
        INVOKE TranslateMessage, ADDR msg
        INVOKE DispatchMessage, ADDR msg
    .ENDW

    mov eax, msg.wParam
    ret

WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF uMsg==WM_CREATE
        INVOKE CreateWindowEx, NULL,\
                               ADDR ProgressClass, NULL, \
                               WS_CHILD+WS_VISIBLE,\
                               50, 70, 300, 20,\
                               hWnd, IDC_PROGRESS, hInstance, NULL
        mov    hwndProgress, eax
        mov    eax, 1000
        mov    CurrentStep, eax
        shl    eax, 16
        INVOKE SendMessage, hwndProgress, PBM_SETRANGE, 0, eax
        INVOKE SendMessage, hwndProgress, PBM_SETSTEP, 10, 0
        INVOKE CreateStatusWindow, WS_CHILD+WS_VISIBLE,\
                                   NULL, hWnd, IDC_STATUS
        mov    hwndStatus, eax
        INVOKE SetTimer, hWnd, IDC_TIMER, 100, NULL
        mov    TimerID, eax
    .ELSEIF uMsg==WM_DESTROY
        INVOKE PostQuitMessage, NULL
        .IF TimerID!=0
            INVOKE KillTimer, hWnd, TimerID
        .ENDIF
    .ELSEIF uMsg==WM_TIMER
        INVOKE SendMessage, hwndProgress, PBM_STEPIT, 0, 0
        sub CurrentStep, 10
        .IF CurrentStep==0
            INVOKE KillTimer, hWnd, TimerID
            mov    TimerID, 0
            INVOKE SendMessage, hwndStatus,\
                                SB_SETTEXT, 0, ADDR Message
            INVOKE MessageBox, hWnd,\
                               ADDR Message, ADDR AppName,\
                               MB_OK+MB_ICONINFORMATION
            INVOKE SendMessage, hwndStatus, SB_SETTEXT, 0, 0
            INVOKE SendMessage, hwndProgress, PBM_SETPOS, 0, 0
        .ENDIF
    .ELSE
        INVOKE DefWindowProc, hWnd, uMsg, wParam, lParam		
        ret
    .ENDIF

    xor eax, eax
    ret

WndProc ENDP

END start
